global function l1nexusLocalClientCommandInit
global function AddLocalClientCommand

global struct LocalClientCommands{
    // command table. Used to identify the root command.
    table<string, array<void functionref(entity, array<string>)> > commands
    // Used to identify the command.
    string prefix
}



global LocalClientCommands localClientCommand

void function l1nexusLocalClientCommandInit()
{
    localClientCommand.prefix = GetConVarString("l1nexus_local_client_command_prefix")

    AddCallback_OnReceivedSayTextMessage(CommandFilter)
    AddDefaultLocalClientCommand()
}

bool function startswith(string str, string cmp)
{
    if (str.slice(0, cmp.len()) == cmp)
        return true
    return false
}

ClClient_MessageStruct function CommandFilter(ClClient_MessageStruct message)
{
    // Logger.logLevel = Logger.LogType["TRACE"]
    
    entity player = GetLocalClientPlayer()
    // if this msg isnt sent by local player, pass
    if (message.player != player)
        return message
    // if msg is not start with the prefix, pass
    if (!startswith(message.message, localClientCommand.prefix))
        return message
    message.shouldBlock = true

    string striped = strip(message.message).slice(localClientCommand.prefix.len()).tolower()

    array<string> args = split(striped, " ")

    string command = args[0]

    // Logger.Debug(command)
    // foreach(arg in args)
    //     Logger.Debug(arg)


    if (!(command in localClientCommand.commands))
        return message



    foreach (func in localClientCommand.commands[command])
        func(player, args)


    return message
}

void function AddLocalClientCommand(string command, void functionref(entity, array<string>) func)
{
    if (!(command in localClientCommand.commands))
    {
        array<void functionref(entity, array<string>)> funcs = []
        localClientCommand.commands[command] <- funcs
    }

    localClientCommand.commands[command].append(func)
}