global function l1nexusLoggerInit


global struct Loggers
{
    void functionref(string) Trace
    void functionref(string) Debug
    void functionref(string) Info
    void functionref(string) Warn
    void functionref(string) Error

    table<string, int> LogType

    int logLevel 
}

global Loggers Logger

void function l1nexusLoggerInit()
{
    Logger.LogType["TRACE"] <- -2;
    Logger.LogType["DEBUG"] <- -1;
    Logger.LogType["INFO"] <- 0;
    Logger.LogType["WARN"] <- 1;
    Logger.LogType["ERROR"] <- 2;

    Logger.logLevel = Logger.LogType["INFO"]
    Logger.Trace = Trace
    Logger.Debug = Debug
    Logger.Info = Info
    Logger.Warn = Warn
    Logger.Error = Error
}

void function Log(string str, string level)
{
    if (!(level in Logger.LogType))
        level = "INFO"
    if (Logger.LogType[level] < Logger.logLevel)
        return
    string color = ""
    // switch(level)
    // {
    //     case "INFO":
    //         color = "`1"
    //         break;
    //     case "WARN":
    //         color = "`2"
    //         break;
    //     case "ERROR":
    //         color = "`3"
    //         break;
    // }

    str = "[" + color + level + "] " + str
    Chat_GameWriteLine(str)
}

void function Trace(string str)
{
    Log(str, "TRACE")
}

void function Debug(string str)
{
    Log(str, "DEBUG")
}

void function Info(string str)
{
    Log(str, "INFO")
}

void function Warn(string str)
{
    Log(str, "WARN")
}

void function Error(string str)
{
    Log(str, "ERROR")
}